<?

// PHP wrapper around ht://dig's htsearch
// Marcel Hicking 20020411 marcel@hichac.de
//
// Modifications:
// 20020411_1507 MH: Changes for standalone operation

// This is a simple wrapper around htsearch.
//
// As I am digging/indexing several countries' web pages
// with my ht://dig installation, I've added a little
// feature to limit the search to a single country.
// You should be able to tweak this for your needs
// easily. It makes use of ht://digs restrict-feature.
// See http://htdig.org/attrs.html#restrict for details.

// Create a separate htdig.conf for this if you
// want to use htsearch directly elsewhere since
// we need some special result template files for
// this!
// Make sure you have a line in you htdig.conf like this:
//   common_dir:       /wherever/htdig/templates/phpwrapper
// 
// Create the following templates in /wherever/htdig/templates/phpwrapper
// All lines start at with the | at the *first* column!
//
// footer.html:
//  (empty)
// 
// short.html:
//  (empty)
// 
// header.html:
//  -----START-HEADER-----
//  |FIRSTDISPLAYED: $(FIRSTDISPLAYED)
//  |FORMAT: $(FORMAT)
//  |LASTDISPLAYED: $(LASTDISPLAYED)
//  |LOGICAL_WORDS: $(LOGICAL_WORDS)
//  |MATCHES: $(MATCHES)
//  |MATCHES_PER_PAGE: $(MATCHES_PER_PAGE)
//  |MATCH_MESSAGE: ${MATCH_MESSAGE}
//  |MAX_STARS: ${MAX_STARS}
//  |METHOD: $(METHOD)
//  |NEXTPAGE: $(NEXTPAGE)
//  |PAGE: $(PAGE)
//  |PAGES: $(PAGES)
//  |PAGEHEADER: $(PAGEHEADER)
//  |PAGELIST: $(PAGELIST)
//  |PREVPAGE: $(PREVPAGE)
//  |PLURAL_MATCHES: $(PLURAL_MATCHES)
//  |SELECTED_FORMAT: $(SELECTED_FORMAT)
//  |SELECTED_METHOD: $(SELECTED_METHOD)
//  |SELECTED_SORT: $(SELECTED_SORT)
//  |SORT: $(SORT)
//  |WORDS: $(WORDS)
//  -----END-HEADER-----
//
// long.html:
//  -----START-SINGLE-RESULT-----
//  CURRENT: $(CURRENT)
//  DESCRIPTION: $(DESCRIPTION)
//  EXCERPT: $(EXCERPT)
//  HOPCOUNT: $(HOPCOUNT)
//  MODIFIED: $(MODIFIED)
//  PERCENT: $(PERCENT)
//  SCORE: $(SCORE)
//  SIZE: $(SIZE)
//  SIZEK: $(SIZEK)
//  STARSLEFT: $(STARSLEFT)
//  STARSRIGHT: $(STARSRIGHT)
//  TITLE: $(TITLE)
//  URL: $(URL)
//  -----END-SINGLE-RESULT-----
//
// nomatch.html:
//  NO MATCH
//  -----START-HEADER-----
//  |FIRSTDISPLAYED: $(FIRSTDISPLAYED)
//  |FORMAT: $(FORMAT)
//  |LASTDISPLAYED: $(LASTDISPLAYED)
//  |LOGICAL_WORDS: $(LOGICAL_WORDS)
//  |MATCHES: $(MATCHES)
//  |MATCHES_PER_PAGE: $(MATCHES_PER_PAGE)
//  |MATCH_MESSAGE: ${MATCH_MESSAGE}
//  |MAX_STARS: ${MAX_STARS}
//  |METHOD: $(METHOD)
//  |NEXTPAGE: $(NEXTPAGE)
//  |PAGE: $(PAGE)
//  |PAGEHEADER: $(PAGEHEADER)
//  |PAGELIST: $(PAGELIST)
//  |PAGES: $(PAGES)
//  |PLURAL_MATCHES: $(PLURAL_MATCHES)
//  |PREVPAGE: $(PREVPAGE)
//  |SELECTED_FORMAT: $(SELECTED_FORMAT)
//  |SELECTED_METHOD: $(SELECTED_METHOD)
//  |SELECTED_SORT: $(SELECTED_SORT)
//  |SORT: $(SORT)
//  |WORDS: $(WORDS)
//  -----END-HEADER-----
//
// syntax.html:
//  SYNTAX ERROR
//  -----START-HEADER-----
//  |FIRSTDISPLAYED: $(FIRSTDISPLAYED)
//  |FORMAT: $(FORMAT)
//  |LASTDISPLAYED: $(LASTDISPLAYED)
//  |LOGICAL_WORDS: $(LOGICAL_WORDS)
//  |MATCHES: $(MATCHES)
//  |MATCHES_PER_PAGE: $(MATCHES_PER_PAGE)
//  |MATCH_MESSAGE: ${MATCH_MESSAGE}
//  |MAX_STARS: ${MAX_STARS}
//  |METHOD: $(METHOD)
//  |NEXTPAGE: $(NEXTPAGE)
//  |PAGE: $(PAGE)
//  |PAGEHEADER: $(PAGEHEADER)
//  |PAGELIST: $(PAGELIST)
//  |PAGES: $(PAGES)
//  |PLURAL_MATCHES: $(PLURAL_MATCHES)
//  |PREVPAGE: $(PREVPAGE)
//  |SELECTED_FORMAT: $(SELECTED_FORMAT)
//  |SELECTED_METHOD: $(SELECTED_METHOD)
//  |SELECTED_SORT: $(SELECTED_SORT)
//  |SORT: $(SORT)
//  |SYNTAXERROR: ${SYNTAXERROR}
//  |WORDS: $(WORDS)
//  -----END-HEADER-----
//





// ------------------------------
// CONFIGURATION AREA
// ------------------------------

// ht://search binary and config
$htsearch_cmd = "/usr/local/htdig/bin/htsearch -c /wherever/htdig/phpwrapper.conf";


// Websites for site specific search
// Modifications: 20011121_2340 MH: Samples
$sites_to_search_default="de";
$sites_to_search[de][identifier]="http://www.our-german-site.de/";
$sites_to_search[de][searchform_name]="Germany";
$sites_to_search[de][icon]="<img src=\"/images/flag_de.gif\" hspace=\"0\" vspace=\"0\" border=\"0\" alt=\"DE\">";

$sites_to_search[com][identifier]="http://www.our-us-site.com/";
$sites_to_search[com][searchform_name]="USA";
$sites_to_search[com][icon]="<img src=\"/images/flag_us.gif\" hspace=\"0\" vspace=\"0\" border=\"0\" alt=\"US\">";

$sites_to_search[fr][identifier]="http://www.our-french-site.fr/";
$sites_to_search[fr][searchform_name]="France";
$sites_to_search[fr][icon]="<img src=\"/images/flag_fr.gif\"  hspace=\"0\" vspace=\"0\" border=\"0\" alt=\"FR\">";

$sites_to_search[at][identifier]="http://www.our-german-site.de/news-archive/";
$sites_to_search[at][searchform_name]="Germany - New archive only";
$sites_to_search[at][icon]="German new archive: ";

// You get the idea...

// EO websites for site search




?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">

<HTML>
<HEAD>
<TITLE>htsearch wrapper</TITLE>
</HEAD>

<BODY bgcolor="#ffffff" text="#000000" link="#000000" alink="#000080" vlink="#a0a0a0">
<font face="arial,helvetica,sans-serif">

<?

// We rip the query string apart ourselves and
//   build a new escaped URL from it right away
$q=preg_split("/[;&]+/",$QUERY_STRING);
for ($c=0;$c<count($q);$c++) {
    list($k,$v)=explode("=",$q[$c]);
    $query[escapeshellcmd(trim($k))]=escapeshellcmd(trim(urldecode($v)));
    // print "DEBUG: querysplit: $k,$v<br>";
} // eo for
unset ($q);


// Make a list of searchable web sites
// Make sure "&restrict" is taken into consideration!
reset ($sites_to_search);
while(list($k,$v)=each($sites_to_search)) {
    $sites_to_search_keylist[$k]=$v[searchform_name];
    if ($query[restrict]==$v[identifier]) {
	$search_on = $k;
    } // eo if
} // eo while


$search_on = $search_on ? $search_on : $sites_to_search_default;
$currentsite=$sites_to_search[$search_on];
// print "DEBUG: Searching on: ". $currentsite[searchform_name] ."<br>";



if ($words) {
    print "<b>Search results:</b><br>\n";
} else {
    print "<b>Search:</b><br>\n";
} // eo if






// DO SEARCH if we have a query string
if ($query[words]) {

    // Build the search command
    $htsearch_cmd.= " 'words=" .$query[words];
    if ($query[page])   $htsearch_cmd.= "&page=" .$query[page];
    if ($query[method]) $htsearch_cmd.= "&method=" .$query[method];
    if ($query[format]) $htsearch_cmd.= "&format=" .$query[format];
    if ($query[sort])   $htsearch_cmd.= "&sort=" .$query[sort];
    $htsearch_cmd.= "&restrict=". $currentsite[identifier];
    $htsearch_cmd.= "'";
    // print "DEBUG: Executing: $htsearch_cmd<br>";
    exec($htsearch_cmd, $output, $retval);
    $in_header=0;
    $in_single_result=0;
    $digresults_count=0;
    
    // Parse output
    for ($c=0;$c<count($output);$c++) {
	// print "DEBUG: ". preg_replace("/</","&lt;",$output[$c]) ."<br>\n";

	if (ereg("^\|",$output[$c])) {
	    $line_continued=0;
	    $line=substr($output[$c],1);
	} else {
	    $line_continued=1;
	    $line=$output[$c];
	}
	if (ereg("-----START-HEADER-----",$line)){
	    $in_header=1;
	    next;
	}
	if (ereg("-----END-HEADER-----",$line)){
	    $in_header=0;
	    next;
	}
	if (ereg("-----START-SINGLE-RESULT-----",$line)){
	    $in_single_result=1;
	    next;
	}
	if (ereg("-----END-SINGLE-RESULT-----",$line)){
	    $in_single_result=0;
	    $digresults_count++;
	    next;
	}

	if ($in_header) {
	    // print "DEBUG: ". preg_replace("/</","&lt;",$line) ."<br>\n";
	    if (!$line_continued) {
		preg_match("/(^[^:]+):(.*)/",$line,$regexmatches);
		// print "DEBUG: $k : $v<br>\n";
		$k=trim($regexmatches[1]);
		$v=trim($regexmatches[2]);
		// print "DEBUG 0: ". trim($regexmatches[0]) ."<br>\n";
		// print "DEBUG 1: ". trim($regexmatches[1]) ."<br>\n";
		// print "DEBUG 2: ". trim($regexmatches[2]) ."<br>\n";
		$digheader[$k]=$v;
	    } else {
		$digheader[$k].= $line;
	    }
	} // eo if in_header

	if ($in_single_result){
		preg_match("/(^[^:]+):[\t ]+(.*)/",$line,$regexmatches);
		$k=trim($regexmatches[1]);
		$k=trim($regexmatches[2]);
		// print "DEBUG 0: ". trim($regexmatches[0]) ."<br>\n";
		// print "DEBUG 1: ". trim($regexmatches[1]) ."<br>\n";
		// print "DEBUG 2: ". trim($regexmatches[2]) ."<br>\n";
		$k = trim($regexmatches[1]);
		$v = trim($regexmatches[2]);
	    // print "DEBUG: **result # $digresults_count:<br>";
	    if ($k && $v) $digresults[$digresults_count][$k]=$v;
	} // eo if in_single_result

    } // eo for
    // EO parse output


    // See what type of result we have

    switch ($output[2]) {
	case "NO MATCH":
	    // -------------------------------------
	    // No hits. Show info. Show search form.
	    // -------------------------------------
	    print "Your search for <i>'" .$digheader[WORDS] ."'</i> did not yield any results.<br>\n";

	    print "Check the spelling of the search word(s) you used. If the spelling is correct and you only used one word, try using one or more similar search words with 'Any'<br>\n";
	    print "If the spelling is correct and you used more than one word with 'Any' try using one or more similar search words with 'Any'<br>\n";
	    print "If the spelling is correct and you used more than one word with 'All' try using one or more of the same words with 'Any'<br>\n";
	    print "<br>\n";
	    print "<b>New search:</b><br>\n";
	    PrintHtdigSearchform($digheader);
	    // PrintHtdigSearchformHelp();
	    break;


	default:
	    // -----------------
	    // Show results
	    // -----------------

	    // Known header:
	    // FIRSTDISPLAYED // FORMAT // LASTDISPLAYED // LOGICAL_WORDS
	    // MATCHES // MATCHES_PER_PAGE // MATCH_MESSAGE // MAX_STARS
	    // METHOD // NEXTPAGE // PAGE // PAGES // PAGEHEADER // PAGELIST
	    // PREVPAGE // PLURAL_MATCHES // SELECTED_FORMAT // SELECTED_METHOD
	    // SELECTED_SORT // SORT // WORDS

	    // Single result:
	    // CURRENT // DESCRIPTION // EXCERPT // HOPCOUNT // MODIFIED
	    // PERCENT // SCORE // SIZE // SIZEK // STARSLEFT // STARSRIGHT
	    // TITLE // URL


	    print "Your search for  <i>'" .$digheader[LOGICAL_WORDS] ."'</i> yielded ". $digheader[MATCHES] ." documents.<br>\n";
	    print "Showing results from  ". $digheader[FIRSTDISPLAYED] ." to ". $digheader[LASTDISPLAYED] .".<br>\n";
	    print "More <img src=\"/images/star_small.gif\" hspace=\"0\" vspace=\"0\" border=\"0\" alt=\"\"> indicate a better hit.<br>\n";
	    print "<br>\n";

	    for ($c=0;$c<count($digresults);$c++) {
		$r=$digresults[$c];
		print $currentsite[icon] ."&nbsp;&nbsp;";
		print $r[CURRENT] ." ";
		print "<a href=\"". $r[URL] . "\">";
		print "<b>". $r[DESCRIPTION] . "</b></a>";
		print " &nbsp;". $r[STARSLEFT];
		print "<br>\n";
		print $r[EXCERPT] . "<br>\n";
		print "<font size=1><small>";
		if ($r[MODIFIED]) print "Last change: ". $r[MODIFIED] ." &nbsp; ";
		print "<a href=\"". $r[URL] ."\">". $r[URL] ."</a>";
		print "</small></font><br>";
		print "<br>\n";
	    } // eo for

	    print "<br>\n";
	    if ($digheader[PREVPAGE]) print $digheader[PREVPAGE] ."&nbsp;&nbsp;&nbsp;";
	    if ($digheader[PAGELIST]) print $digheader[PAGELIST];
	    if ($digheader[NEXTPAGE]) print "&nbsp;&nbsp;&nbsp;". $digheader[NEXTPAGE];
	    print "<br>\n";
	    print "<hr noshade size=1>\n";
	    print "<b>New search:</b><br>\n";
	    PrintHtdigSearchform($digheader);
	    print "<br>\n";
	    print "<br>\n";

	    break;
	} // eo switch


} else {
    // Show search form if no query string
    print "<br>\n";
    // Fake a digheader:
    $digheader[FORMAT]="<select name=\"format\"><option value=\"long\">Detailed<option value=\"short\">Overview</select>\n";
    $digheader[SORT]="<select name=\"sort\">\n<option value=\"score\" selected>Score\n<option value=\"time\">Date/time\n<option value=\"title\">Title\n<option value=\"revscore\">Score (lowest first)\n<option value=\"revtime\">Date / Time(latest first)\n<option value=\"revtitle\">Title (Z-A)\n</select>\n";
    $digheader[METHOD]="<select name=\"method\">\n<option value=\"and\" selected>All terms\n<option value=\"or\">At least one term\n<option value=\"boolean\">With AND,OR,NOT etc.\n</select>\n";
    PrintHtdigSearchform($digheader);

    print "<br>\n";
    PrintHtdigSearchformhelp();
    print "<br>\n";

} // eo $query[words] ?




function PrintHtdigSearchform($digheader) {
    // PrintSearchform
    // Parameters:    Array $digheader
    // Returns:       -
    // Prerequisites: -
    // Modifications: 20020411_1505 MH: Changes for standalone operation
    // Modifications: 20011119_1557 MH: Init

    global $PHP_SELF;
    // htdig keywords
    global $action,$words,$page,$method,$format,$sort,$search_on;
    global $sites_to_search,$sites_to_search_default;

    // Liste durchsuchbarer Website erstellen
    reset ($sites_to_search);
    while(list($k,$v)=each($sites_to_search)) {
	$sites_to_search_keylist[$k]=$v[searchform_name];
    }
    $search_on = $search_on ? $search_on : $sites_to_search_default;


    print "<form method=\"get\" action=\"$PHP_SELF\">\n";
    print "<input type=\"hidden\" name=\"action[sitesearch]\" value=\"1\">\n";
    print "<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\">\n";
    print "<tr>\n";
    print "<td colspan=\"5\" align=\"left\"><FONT face=\"arial,helvetica,sans-serif\" size=\"1\">\n";
    print "<input type=\"text\" size=\"40\" name=\"words\" value=\"". $digheader[WORDS] ."\">&nbsp;&nbsp;<input type=\"submit\" value=\"Search\"><br>\n";
    print "</font></td>\n";
    print "</tr>\n";

    print "<tr>\n";
    print "<td align=\"left\"><font face=\"arial,helvetica,sans-serif\" size=\"1\">\n";
    print "Type of search:<br>\n";
    print $digheader[METHOD] ."<br>\n";
    print "</font></td>\n";
    print "<td>&nbsp;<br></td>\n";

    print "<td align=\"left\"><font face=\"arial,helvetica,sans-serif\" size=\"1\">\n";
    print "Sort by:<br>\n";
    print $digheader[SORT] ."<br>\n";
    print "</font></td>\n";

    print "</tr>\n";


    print "<tr>\n";
    print "<td colspan=\"5\" align=\"left\"><FONT face=\"arial,helvetica,sans-serif\" size=\"1\">\n";
    print "<br>";
    print "Search web pages in &nbsp;<br>\n";
    while(list($k,$v)=each($sites_to_search_keylist)) {
	$chkd = ($search_on == $k ) ? " checked" : "";
	print "<input type=\"radio\" name=\"search_on\" value=\"$k\" $chkd> $v &nbsp; ";
	unset ($chkd);

    } // eo while sites_to_search_keylist

    print "</font></td>\n";
    print "</tr>\n";


    print "</table>\n";
    print "</form>\n";
} // eo fkt PrintSearchform



function PrintHtdigSearchformhelp() {
    // PrintSearchformhelp
    // Parameters: 
    // Returns:       -
    // Prerequisites: -
    // Modifications: 20020411_1505 MH: Changes for standalone operation
    // Modifications: 20011119_1558 MH: Init

    global $PHP_SELF;
    global $action,$words,$page,$method,$format,$sort;

    // Put help here
} // eo fkt PrintSearchformhelp

?>

</font>
</BODY>
</HTML>
